.386
.model flat, stdcall  ;32 bit memory model
option casemap :none  ;case sensitive

include ComboBoxEx.inc

.code

start:

	invoke GetModuleHandle,NULL
	mov		hInstance,eax

    invoke InitCommonControls
	mov		iccex.dwSize,sizeof INITCOMMONCONTROLSEX    ;prepare common control structure
	mov		iccex.dwICC,ICC_USEREX_CLASSES
	invoke InitCommonControlsEx,addr iccex
	invoke DialogBoxParam,hInstance,IDD_DLG1,NULL,addr DlgProc,NULL
	invoke ExitProcess,0

;########################################################################

DlgProc proc hWin:HWND,uMsg:UINT,wParam:WPARAM,lParam:LPARAM
	LOCAL	hBmp:DWORD
	LOCAL	cbi:COMBOBOXEXITEM

	mov		eax,uMsg
	.if eax==WM_INITDIALOG
		invoke GetDlgItem,hWin,IDC_CBE1
		mov		hCbo,eax
	    invoke ImageList_Create,15,15,ILC_COLOR8,8,0
	    mov     hIml,eax
	    invoke LoadBitmap,hInstance,IDB_COLOR
	    mov     hBmp,eax
	    invoke ImageList_Add,hIml,hBmp,NULL
	    invoke DeleteObject,hBmp
		invoke SendMessage,hCbo,CBEM_SETIMAGELIST,0,hIml
		mov		cbi.fmask,CBEIF_IMAGE or CBEIF_TEXT or CBEIF_SELECTEDIMAGE
		mov		cbi.pszText,offset szComboBoxEx
		mov		cbi.cchTextMax, sizeof szComboBoxEx
		xor		eax,eax
		.while eax<8
			push	eax
			mov		cbi.iItem,eax
			mov		cbi.iImage,eax
			mov		cbi.iSelectedImage,eax
			invoke SendMessage,hCbo,CBEM_INSERTITEM,0,addr cbi
			pop		eax
			inc		eax
		.endw
		invoke SendMessage,hCbo,CB_SETCURSEL,0,0
	.elseif eax==WM_COMMAND
		mov		eax,wParam
		mov		edx,eax
		shr		edx,16
		and		eax,0FFFFh
		.if edx==BN_CLICKED
			.if eax==IDCANCEL
				invoke SendMessage,hWin,WM_CLOSE,NULL,NULL
			.endif
		.endif
	.elseif eax==WM_CLOSE
		invoke EndDialog,hWin,0
	.else
		mov		eax,FALSE
		ret
	.endif
	mov		eax,TRUE
	ret

DlgProc endp

end start
