.386
.model flat, stdcall  ;32 bit memory model
option casemap :none  ;case sensitive

include CtlColor.inc

.code

start:

	invoke GetModuleHandle,NULL
	mov		hInstance,eax

	invoke DialogBoxParam,hInstance,IDD_DIALOG1,NULL,addr DlgProc,NULL
	invoke ExitProcess,0

;########################################################################

DlgProc proc hWin:HWND,uMsg:UINT,wParam:WPARAM,lParam:LPARAM

	mov		eax,uMsg
	.if eax==WM_INITDIALOG
		invoke SetTimer,hWin,200,50,NULL
	.elseif eax==WM_TIMER
		add ColorRef,030507h
		and ColorRef,0FFFFFFh
		invoke GetDlgItem,hWin,1001
		invoke InvalidateRect,eax,NULL,TRUE
		invoke GetDlgItem,hWin,1002
		invoke InvalidateRect,eax,NULL,TRUE
		invoke GetDlgItem,hWin,1003
		invoke InvalidateRect,eax,NULL,TRUE
	.elseif eax==WM_COMMAND
        mov eax,wParam
        mov edx,eax
        shr edx,16
        .if dx==BN_CLICKED
            .if ax==IDOK
				invoke MessageBox,hWin,addr szMsg,addr szMsg,MB_OK
            .elseif ax==IDCANCEL
				invoke SendMessage,hWin,WM_CLOSE,0,0
			.endif
		.endif
	.elseif eax==WM_CTLCOLORSTATIC
		invoke GetWindowLong,lParam,GWL_ID
		.if eax==1001
			.if hBrush
				invoke DeleteObject,hBrush
			.endif
			mov		eax,ColorRef
			xor		eax,0FFh
			invoke CreateSolidBrush,eax
			mov		hBrush,eax
			ret
		.endif
		mov eax,FALSE
		ret
	.elseif eax==WM_CTLCOLOREDIT
		invoke GetWindowLong,lParam,GWL_ID
		.if eax==1002
			.if hBrush
				invoke DeleteObject,hBrush
			.endif
			invoke SetBkMode,wParam,TRANSPARENT
			mov		eax,ColorRef
			xor		eax,0FF00H
			invoke CreateSolidBrush,eax
			mov		hBrush,eax
			ret
		.elseif eax==1003
			.if hBrush
				invoke DeleteObject,hBrush
			.endif
			invoke SetBkMode,wParam,TRANSPARENT
			INVOKE SetTextColor,wParam,0FFFFh
			mov		eax,ColorRef
			xor		eax,0FF0000H
			invoke CreateSolidBrush,eax
			mov		hBrush,eax
			ret
		.endif
		mov eax,FALSE
		ret
	.elseif eax==WM_CLOSE
		invoke KillTimer,hWin,200
		invoke DeleteObject,hBrush
		invoke EndDialog,hWin,0
	.else
		mov		eax,FALSE
		ret
	.endif
	mov		eax,TRUE
	ret

DlgProc endp

end start
