;
;--------------------------------------------------------------------------------
;NOTE:	This demo will only show SQL_CHAR, SQL_VARCHAR and SQL_INTEGER columns.
;		It will not work with unicode.
;		Will only work with AutoIncrement PrimaryKey.
;		In parts based on MsdnHelp by Qweerdy
;--------------------------------------------------------------------------------
;
.386
.model flat, stdcall  ;32 bit memory model
option casemap :none  ;case sensitive

include ODBCTest.inc
includelib RAGrid.lib
include RAGrid.inc
include DataBase.asm

.code

start:

	invoke GetModuleHandle,NULL
	mov		hInstance,eax
	invoke GridInstall,eax
    invoke InitCommonControls
	invoke DialogBoxParam,hInstance,IDD_DIALOG1,NULL,addr DlgProc,NULL
	invoke ExitProcess,0

DlgProc proc uses esi,hWin:HWND,uMsg:UINT,wParam:WPARAM,lParam:LPARAM
	LOCAL	col:COLUMN
	LOCAL	rect:RECT
	LOCAL	rowdta[4]:DWORD
	LOCAL	nRow:DWORD

	mov		eax,uMsg
	.if eax==WM_INITDIALOG
		mov		eax,hWin
		mov		hWnd,eax
		invoke GetDlgItem,hWin,IDC_GRD1
		mov		hGrd,eax
		invoke SendMessage,hGrd,GM_SETBACKCOLOR,0C0FFFFh,0
		invoke SendMessage,hGrd,GM_SETGRIDCOLOR,808080h,0
		invoke SendMessage,hGrd,GM_SETTEXTCOLOR,800000h,0
		mov		col.colwt,60
		mov		col.lpszhdrtext,offset szHdrID
		mov		col.halign,GA_ALIGN_RIGHT
		mov		col.calign,GA_ALIGN_RIGHT
		mov		col.ctype,TYPE_EDITLONG
		mov		col.ctextmax,11
		mov		col.lpszformat,0
		mov		col.himl,0
		mov		col.hdrflag,0
		invoke SendMessage,hGrd,GM_ADDCOL,0,addr col
		mov		col.colwt,140
		mov		col.lpszhdrtext,offset szHdrName
		mov		col.halign,GA_ALIGN_LEFT
		mov		col.calign,GA_ALIGN_LEFT
		mov		col.ctype,TYPE_EDITTEXT
		mov		col.ctextmax,25
		mov		col.lpszformat,0
		mov		col.himl,0
		mov		col.hdrflag,0
		invoke SendMessage,hGrd,GM_ADDCOL,0,addr col
		mov		col.colwt,140
		mov		col.lpszhdrtext,offset szHdrSurName
		mov		col.halign,GA_ALIGN_LEFT
		mov		col.calign,GA_ALIGN_LEFT
		mov		col.ctype,TYPE_EDITTEXT
		mov		col.ctextmax,25
		mov		col.lpszformat,0
		mov		col.himl,0
		mov		col.hdrflag,0
		invoke SendMessage,hGrd,GM_ADDCOL,0,addr col
		mov		col.colwt,120
		mov		col.lpszhdrtext,offset szHdrTelephoneNo
		mov		col.halign,GA_ALIGN_LEFT
		mov		col.calign,GA_ALIGN_LEFT
		mov		col.ctype,TYPE_EDITTEXT
		mov		col.ctextmax,20
		mov		col.lpszformat,0
		mov		col.himl,0
		mov		col.hdrflag,0
		invoke SendMessage,hGrd,GM_ADDCOL,0,addr col
		invoke ODBCConnect,addr szDBName
		invoke ODBCGetData,addr cust
		xor		eax,eax
		jmp		Ex
	.elseif eax==WM_SIZE
		invoke GetClientRect,hWin,addr rect
		add		rect.left,3
		add		rect.top,3
		sub		rect.right,3+3
		sub		rect.bottom,3+21+3+3
		invoke MoveWindow,hGrd,rect.left,rect.top,rect.right,rect.bottom,TRUE

		invoke GetClientRect,hWin,addr rect
		invoke GetDlgItem,hWin,IDCANCEL
		sub		rect.bottom,22
		sub		rect.right,3
		mov		ecx,rect.bottom
		mov		edx,rect.right
		sub		edx,64
		invoke MoveWindow,eax,edx,ecx,64,21,TRUE
		invoke GetDlgItem,hWin,IDC_BTNDEL
		mov		ecx,rect.bottom
		mov		edx,rect.right
		sub		edx,64+3+64
		invoke MoveWindow,eax,edx,ecx,64,21,TRUE
		invoke GetDlgItem,hWin,IDC_BTNADD
		mov		ecx,rect.bottom
		mov		edx,rect.right
		sub		edx,64+3+64+3+64
		invoke MoveWindow,eax,edx,ecx,64,21,TRUE
	.elseif eax==WM_COMMAND
		mov		edx,wParam
		movzx	eax,dx
		shr		edx,16
		.if edx==BN_CLICKED
			.if eax==IDCANCEL
				invoke SendMessage,hWin,WM_CLOSE,NULL,NULL
			.elseif eax==IDC_BTNADD
				;Add a new empty row
				mov		cust.szName,0
				mov		cust.lenName,SQL_NULL_DATA
				mov		cust.szSurname,0
				mov		cust.lenSurname,SQL_NULL_DATA
				mov		cust.szTelephoneNo,0
				mov		cust.lenTelephoneNo,SQL_NULL_DATA
				invoke ODBCAddData,addr cust
				.if !eax
					invoke ODBCGetRowData,addr cust
					mov		eax,cust.nID
					mov		rowdta,eax
					lea		eax,cust.szName
					mov		rowdta+4,eax
					lea		eax,cust.szSurname
					mov		rowdta+8,eax
					lea		eax,cust.szTelephoneNo
					mov		rowdta+12,eax
					invoke SendMessage,hGrd,GM_ADDROW,0,addr rowdta
					invoke SendMessage,hGrd,GM_SETCURSEL,0,eax
				.endif
			.elseif eax==IDC_BTNDEL
				;Delete a row
				invoke SendMessage,hGrd,GM_GETCURROW,0,0
				.if sdword ptr eax>=0
					mov		nRow,eax
					mov		ecx,eax
					shl		ecx,16
					invoke SendMessage,hGrd,GM_GETCELLDATA,ecx,addr cust.nID
					invoke ODBCDelete,addr cust
					.if !eax
						invoke SendMessage,hGrd,GM_DELROW,nRow,0
						invoke SendMessage,hGrd,GM_SETCURSEL,0,nRow
					.endif
				.endif
			.endif
			invoke SetFocus,hGrd
			xor		eax,eax
			jmp		Ex
		.endif
	.elseif eax==WM_NOTIFY
		mov		esi,lParam
		mov		eax,[esi].NMHDR.hwndFrom
		.if eax==hGrd
			mov		eax,[esi].NMHDR.code
			.if eax==GN_HEADERCLICK
				;Sort the grid by column, invert sorting order
				invoke SendMessage,hGrd,GM_COLUMNSORT,[esi].GRIDNOTIFY.col,SORT_INVERT
			.elseif eax==GN_BEFOREEDIT
				;Prevent edit of AutoIncrement
				.if ![esi].GRIDNOTIFY.col
					mov		[esi].GRIDNOTIFY.fcancel,TRUE
				.endif
			.elseif eax==GN_AFTERUPDATE
				;Update a cell
				mov		ecx,[esi].GRIDNOTIFY.row
				shl		ecx,16
				invoke SendMessage,hGrd,GM_GETCELLDATA,ecx,addr cust.nID
				mov		ecx,[esi].GRIDNOTIFY.row
				shl		ecx,16
				add		ecx,1
				invoke SendMessage,hGrd,GM_GETCELLDATA,ecx,addr cust.szName
				invoke lstrlen,addr cust.szName
				.if !eax
					mov		eax,SQL_NULL_DATA
				.endif
				mov		cust.lenName,eax
				mov		ecx,[esi].GRIDNOTIFY.row
				shl		ecx,16
				add		ecx,2
				invoke SendMessage,hGrd,GM_GETCELLDATA,ecx,addr cust.szSurname
				invoke lstrlen,addr cust.szSurname
				.if !eax
					mov		eax,SQL_NULL_DATA
				.endif
				mov		cust.lenSurname,eax
				mov		ecx,[esi].GRIDNOTIFY.row
				shl		ecx,16
				add		ecx,3
				invoke SendMessage,hGrd,GM_GETCELLDATA,ecx,addr cust.szTelephoneNo
				invoke lstrlen,addr cust.szTelephoneNo
				.if !eax
					mov		eax,SQL_NULL_DATA
				.endif
				mov		cust.lenTelephoneNo,eax
				invoke ODBCUpdateData,addr cust
			.endif
		.endif
	.elseif eax==WM_CLOSE
		invoke ODBCDisconnect
		invoke EndDialog,hWin,0
	.else
		mov		eax,FALSE
		ret
	.endif
	mov		eax,TRUE
  Ex:
	ret

DlgProc endp

end start
