; ####################################################
;       Based on example by:
;       William F. Cravener 5/27/2003
; ####################################################

.386
.model flat, stdcall  ;32 bit memory model
option casemap :none  ;case sensitive

include PlayMidi.inc

.code

start:

	invoke GetModuleHandle,NULL
	mov		hInstance,eax
    invoke InitCommonControls
	invoke DialogBoxParam,hInstance,IDD_DIALOG1,NULL,addr DlgProc,NULL
	invoke ExitProcess,0

;########################################################################

PlayMidiFile proc hWin:DWORD,NameOfFile:DWORD
	LOCAL	mciOpenParms:MCI_OPEN_PARMS,mciPlayParms:MCI_PLAY_PARMS

	mov		eax,hWin        
	mov		mciPlayParms.dwCallback,eax
	mov		eax,OFFSET szMIDISeqr
	mov		mciOpenParms.lpstrDeviceType,eax
	mov		eax,NameOfFile
	mov		mciOpenParms.lpstrElementName,eax
	invoke mciSendCommand,0,MCI_OPEN,MCI_OPEN_TYPE or MCI_OPEN_ELEMENT,ADDR mciOpenParms
	mov		eax,mciOpenParms.wDeviceID
	mov		MidDeviceID,eax
	invoke mciSendCommand,MidDeviceID,MCI_PLAY,MCI_NOTIFY,ADDR mciPlayParms
	ret  

PlayMidiFile endp


DlgProc proc hWin:HWND,uMsg:UINT,wParam:WPARAM,lParam:LPARAM

	mov		eax,uMsg
	.if eax==WM_INITDIALOG

	.elseif eax==WM_COMMAND
		mov		edx,wParam
		movzx	eax,dx
		shr		edx,16
		.if edx==BN_CLICKED
			.if eax==1001
				invoke PlayMidiFile,hWin,addr FileName
			.elseif eax==1002
				invoke mciSendCommand,MidDeviceID,MCI_CLOSE,0,0
			.endif
		.endif
	.elseif eax==WM_CLOSE
		invoke EndDialog,hWin,0
	.elseif eax==MM_MCINOTIFY
		; sent when media play completes and closes midi device
		invoke mciSendCommand,MidDeviceID,MCI_CLOSE,0,0
	.else
		mov		eax,FALSE
		ret
	.endif
	mov		eax,TRUE
	ret

DlgProc endp

end start
