.386
.model flat, stdcall  ;32 bit memory model
option casemap :none  ;case sensitive

include SpaceTrim.inc

.code

start:

	invoke GetModuleHandle,NULL
	mov		hInstance,eax

    invoke InitCommonControls
	invoke DialogBoxParam,hInstance,IDD_DIALOG1,NULL,addr DlgProc,NULL
	invoke ExitProcess,0

;########################################################################

;Trim off leading and trailing spaces. Removes double spaces.
;lpBuff points to memory buffer
SpaceTrim proc uses esi edi,lpBuff:DWORD

	mov		esi,lpBuff
	mov		edi,lpBuff
	xor		edx,edx
	xor		eax,eax
	mov		ah,0Ah
  @@:
	lodsb
	.if al==' '
		inc		edx
	.else
		.if edx && al && al!=0Dh && ah!=0Ah
			mov		byte ptr [edi],' '
			inc		edi
		.endif
		stosb
		mov		ah,al
		xor		edx,edx
	.endif
	or		al,al
	jne		@b
	ret

SpaceTrim endp

DlgProc proc hWin:HWND,uMsg:UINT,wParam:WPARAM,lParam:LPARAM

	mov		eax,uMsg
	.if eax==WM_INITDIALOG
		invoke SendDlgItemMessage,hWin,IDC_EDT1,WM_SETTEXT,0,offset szSomeText
	.elseif eax==WM_COMMAND
		mov		eax,wParam
		mov		edx,eax
		shr		edx,16
		and		eax,0FFFFh
		.if edx==BN_CLICKED
			.if eax==IDOK
				invoke SendDlgItemMessage,hWin,IDC_EDT1,WM_GETTEXT,sizeof buffer,offset buffer
				invoke SpaceTrim,offset buffer
				invoke SendDlgItemMessage,hWin,IDC_EDT1,WM_SETTEXT,0,offset buffer
			.elseif eax==IDCANCEL
				invoke SendMessage,hWin,WM_CLOSE,NULL,NULL
			.endif
		.endif
	.elseif eax==WM_CLOSE
		invoke EndDialog,hWin,0
	.else
		mov		eax,FALSE
		ret
	.endif
	mov		eax,TRUE
	ret

DlgProc endp

end start
